'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var path = require('path');
var EventEmitter = require('events');
var loadSwaggerSpec = require('./swagger/load');

// TODO: mixing responsibilities: project encapsulation and application should be separate

var Bombastic = function (_EventEmitter) {
  _inherits(Bombastic, _EventEmitter);

  function Bombastic() {
    var projectPath = arguments.length <= 0 || arguments[0] === undefined ? process.cwd() : arguments[0];

    _classCallCheck(this, Bombastic);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Bombastic).call(this));

    _this.path = projectPath;
    _this.configPath = path.join(_this.path, 'bombastic');
    return _this;
  }

  _createClass(Bombastic, [{
    key: 'run',
    value: function () {
      var _ref = _asyncToGenerator(function* (commandName) {
        var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

        var command = this.command(commandName);
        return yield command(this, options);
      });

      function run(_x3) {
        return _ref.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: 'command',
    value: function command(commandName) {
      var sanitizedCommandName = commandName.replace(/[./\\]/g, '');

      // eslint-disable-next-line global-require
      return require('./' + path.join(sanitizedCommandName, 'command'));
    }
  }, {
    key: 'config',
    value: function config() {
      if (this.cachedConfig) {
        return this.cachedConfig;
      }

      var config = {};
      try {
        // eslint-disable-next-line global-require
        config = require(this.configPath);
      } catch (err) {
        this.log('warn', 'Could not load bombastic config at \'' + this.configPath + '\'.');
      }

      this.cachedConfig = config;

      return config;
    }
  }, {
    key: 'swagger',
    value: function () {
      var _ref2 = _asyncToGenerator(function* () {
        if (this.swaggerSpec) {
          return this.swaggerSpec;
        }

        this.swaggerSpec = yield loadSwaggerSpec(path.join(this.path, 'swagger.yaml'));
        return this.swaggerSpec;
      });

      function swagger() {
        return _ref2.apply(this, arguments);
      }

      return swagger;
    }()
  }, {
    key: 'log',
    value: function log(level) {
      for (var _len = arguments.length, messages = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        messages[_key - 1] = arguments[_key];
      }

      this.emit.apply(this, ['log', level].concat(messages));
    }
  }, {
    key: 'startWaiting',
    value: function startWaiting() {
      this.emit('waiting', true);
    }
  }, {
    key: 'stopWaiting',
    value: function stopWaiting() {
      this.emit('waiting', false);
    }
  }, {
    key: 'setCustomConfigPath',
    value: function setCustomConfigPath(configPath) {
      this.configPath = configPath;
    }
  }]);

  return Bombastic;
}(EventEmitter);

module.exports = Bombastic;