'use strict';

/**
 * TODO (document available options)
 */
var deploy = function () {
  var _ref = _asyncToGenerator(function* (project) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    var platform = getPlatformOption(options);
    var teardown = options.teardown;

    var deployModuleName = DEPLOY_MODULE_PREFIX + platform;

    // eslint-disable-next-line global-require
    var deployModule = require(deployModuleName);

    return yield deployModule(project, { teardown: teardown });
  });

  return function deploy(_x2) {
    return _ref.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

module.exports = deploy;

var DEPLOY_MODULE_PREFIX = 'bombastic-deploy-';

function getPlatformOption(options) {
  var platform = options.platform;


  if (!platform) {
    throw new Error('No platform specified. The third argument must be the name of the ' + 'platform to deploy to (eg, ECS, Serverless).');
  }

  // sanitize platform
  platform = platform.replace(/[^a-zA-Z0-9_-]/g, '').toLowerCase();

  return platform;
}

deploy.allowedOptions = {
  _: [{ name: 'platform', type: 'string' }],
  teardown: 'bool'
};