'use strict';

/**
 * TODO (document available options, ie, port/useSsl)
 */
var serve = function () {
  var _ref = _asyncToGenerator(function* (app) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    var framework = options.framework;


    if (!framework) {
      throw new Error('No framework specified. The third argument must be the name of the ' + 'framework to serve with.');
    }

    // sanitize framework
    framework = framework.replace(/[^a-zA-Z0-9_-]/g, '').toLowerCase();

    var serveModuleName = SERVE_MODULE_PREFIX + framework;

    // eslint-disable-next-line global-require
    var serveModule = require(serveModuleName);

    return yield serveModule(app, Object.assign({}, options));
  });

  return function serve(_x2) {
    return _ref.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

module.exports = serve;

var SERVE_MODULE_PREFIX = 'bombastic-serve-';

serve.allowedOptions = {
  _: [{ name: 'framework', type: 'string' }],
  port: 'int',
  useSsl: 'bool'
};