'use strict';

var RouteHandler = require('../route-handler');

var ROUTE_HANDLER_KEY = 'x-route-handler';

module.exports = replaceRouteHandlers;

function replaceRouteHandlers(swagger) {
  Object.keys(swagger.paths).forEach(function eachPath(path) {
    var pathObj = swagger.paths[path];
    Object.keys(pathObj).forEach(function eachMethod(method) {
      pathObj[method][ROUTE_HANDLER_KEY] = makeRouteHandler(method + ' ' + path, pathObj[method]);
    });
  });

  return swagger;
}

function makeRouteHandler(routeId, route) {
  var routeHandler = route[ROUTE_HANDLER_KEY];
  if (!routeHandler) {
    throw new Error('Invalid swagger spec, no x-route-handler found for ' + routeId + '. ' + 'Without it, there\'s no way to know what node.js function to invoke.');
  }

  return new RouteHandler(routeHandler);
}