'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var path = require('path');

var ROUTE_HANDLER_FORMAT = 'methodName@path/relative/to/project/root';

// NOTE: method is allowed to be empty (so the default export can be used)

var RouteHandler = function () {
  function RouteHandler(spec) {
    _classCallCheck(this, RouteHandler);

    var _spec$split = spec.split('@');

    var _spec$split2 = _slicedToArray(_spec$split, 2);

    var method = _spec$split2[0];
    var modulePath = _spec$split2[1];


    if (!modulePath) {
      throw new Error('Invalid route handler: ' + spec + '. Required format is ' + ROUTE_HANDLER_FORMAT);
    }

    this.method = method;
    this.path = modulePath.replace(/[.]/g, '');
  }

  _createClass(RouteHandler, [{
    key: 'getActual',
    value: function getActual(basePath) {
      var fullPath = path.join(basePath, this.path);

      // eslint-disable-next-line global-require
      var module = require(fullPath);
      var handler = this.method ? module[this.method] : module;

      if (!handler) {
        throw new Error('Cannot find route handler method \'' + this.method + '\' in module ' + this.path + '.');
      }

      if (!(handler instanceof Function)) {
        throw new Error('Route handler \'' + this.method + '\' in module ' + this.path + ' is not a Function.');
      }

      return handler;
    }
  }]);

  return RouteHandler;
}();

module.exports = RouteHandler;